package com.agiledeveloper;

import java.util.Arrays;

public class GameOfLife {
  boolean isAlive(boolean live, int numberOfNeighbors) {
    return live && numberOfNeighbors == 2 || numberOfNeighbors == 3;
  }
  
  int getLiveNeighborCount(boolean[][] landscape, int row, int column) {
    int count = 0;
    for (int i = row - 1; i <= row + 1; i++) {
      for (int j = column - 1; j <= column + 1; j++) {
        if(isCellAlive(landscape, i, j)) count++;
      }
    }
    
    return landscape[row][column] ? count - 1: count;
  } 
  
  private boolean isCellAlive(boolean[][] landscape, int row, int column) {
    return (row > -1 && column > -1 && row < landscape.length 
      && column < landscape[0].length
      && landscape[row][column]);
  }
  
  public boolean[][] nextGeneration(boolean[][] land) {
    boolean[][] nextGenerationLand = new boolean[land.length][land[0].length];
    for(int i = 0; i < land.length; i++)
      for(int j = 0; j < land[0].length; j++)
        nextGenerationLand[i][j] = 
          isAlive(land[i][j], getLiveNeighborCount(land, i, j));
    return nextGenerationLand;
  }
}
